/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */

using System;
using org.eclipse.emf.common.notify;
using org.eclipse.emf.common.notify.impl;
using org.eclipse.emf.ecore;
using po;


namespace po.util
{

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see po.PoPackage
 * @generated
 * AdapterFactoryClass template line 41
 */
public class PoAdapterFactory : AdapterFactoryImpl
{
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * AdapterFactoryClass template line 60
	 */
	protected static PoPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * AdapterFactoryClass template line 69
	 */
	public PoAdapterFactory()
	{
		modelSwitch = new InternalPoSwitch<Adapter>(this);
		if (modelPackage == null)
		{
			modelPackage = PoPackage_Constants.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 * AdapterFactoryClass template line 86
	 */
	public override bool isFactoryForType(Object theObject)
	{
		if (theObject == modelPackage)
		{
			return true;
		}
		if (theObject is EObject)
		{
			return ((EObject)theObject).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * AdapterFactoryClass template line 109
	 */
	protected PoSwitch<Adapter> modelSwitch = null;

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 * AdapterFactoryClass template line 139
	 */
	public Adapter createAdapter(Notifier target)
	{
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link po.PurchaseOrder <em>Purchase Order</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see po.PurchaseOrder
	 * @generated
	 * AdapterFactoryClass template line 160
	 */
	public virtual Adapter createPurchaseOrderAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link po.Item <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see po.Item
	 * @generated
	 * AdapterFactoryClass template line 160
	 */
	public virtual Adapter createItemAdapter()
	{
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 * AdapterFactoryClass template line 175
	 */
	public virtual Adapter createEObjectAdapter()
	{
		return null;
	}

} //PoAdapterFactory

		
internal class InternalPoSwitch<T> : PoSwitch<Adapter> where T : Adapter
{

	private PoAdapterFactory outerClassObject;

    internal InternalPoSwitch(PoAdapterFactory outerClassObject) : base()
    {
        this.outerClassObject = outerClassObject;
    }

	public override Adapter casePurchaseOrder(PurchaseOrder theObject)
	{
		return outerClassObject.createPurchaseOrderAdapter();
	}
	
	public override Adapter caseItem(Item theObject)
	{
		return outerClassObject.createItemAdapter();
	}
	
	public override Adapter defaultCase(EObject theObject)
	{
		return outerClassObject.createEObjectAdapter();
	}
}


} // end of namespace po.util