/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */

using System;
using System.Collections.Generic;
using org.eclipse.emf.ecore;
using po;


namespace po.util
{

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see po.PoPackage
 * @generated
 * SwitchClass template line 70 
 */
public class PoSwitch<T>
{
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * SwitchClass template line 89
	 */
	protected static PoPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * SwitchClass template line 98
	 */
	public PoSwitch()
	{
		if (modelPackage == null)
		{                  
			modelPackage = PoPackage_Constants.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 * SwitchClass template line 114
	 */
	public T doSwitch(EObject theEObject)
	{
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 * SwitchClass template line 127
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject)
	{
		if (theEClass.EContainer() == modelPackage)
		{
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else
		{
			IList<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.Count<1 ? // poor mans isEmpty() ... TODO better solutions in C#?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes[0], theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 * SwitchClass template line 151
	 */
	protected T doSwitch(int classifierID, EObject theEObject)
	{
		switch (classifierID)
		{
			case PoPackage_Constants.PURCHASE_ORDER:
			{
				PurchaseOrder purchaseOrder = (PurchaseOrder)theEObject;
				T result = casePurchaseOrder(purchaseOrder);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PoPackage_Constants.ITEM:
			{
				Item item = (Item)theEObject;
				T result = caseItem(item);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Purchase Order</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Purchase Order</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 * SwitchClass template line 186
	 */
	public virtual T casePurchaseOrder(PurchaseOrder theObject)
	{
		return default(T);
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Item</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Item</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 * SwitchClass template line 186
	 */
	public virtual T caseItem(Item theObject)
	{
		return default(T);
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 * SwitchClass template line 204
	 */
	public virtual T defaultCase(EObject theObject)
	{
		return default(T);
	}

} //PoSwitch

} // end of namespace po.util
